// Fill out your copyright notice in the Description page of Project Settings.


#include "HealOverTime.h"

#include "COMP250_1_2101327_AI/Player/PlayerCharacter.h"

void UHealOverTime::Heal(AActor* Character, const float Amount) const
{
	if (APlayerCharacter* CastedCharacter = Cast<APlayerCharacter>(Character); CastedCharacter->Health < 100)
	{
		CastedCharacter->Health += Amount;
	}
	else
	{
		CastedCharacter->Health = 100;
	}
}

void UHealOverTime::Invoke(AActor* Character, float TimeOfExpiry)
{
	Super::Invoke(Character, TimeOfExpiry);
	GetWorld()->GetTimerManager().SetTimer(HealTimerHandle, [this, Character] { Heal(Character, 1); }, 1, true, 0);
}

void UHealOverTime::OnExpiry(AActor* Character)
{
	GetWorld()->GetTimerManager().ClearTimer(HealTimerHandle);
	Super::OnExpiry(Character);
}
